"""autogenerated by genmsg_py from MultiInterfaceStatus.msg. Do not edit."""
import roslib.message
import struct

import wpa_supplicant_node.msg
import multi_interface_roam.msg
import roslib.rostime

class MultiInterfaceStatus(roslib.message.Message):
  _md5sum = "8cc48fc7b9fd9a6f7f5e63eb7bc51745"
  _type = "multi_interface_roam/MultiInterfaceStatus"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """InterfaceStatus[] interfaces

================================================================================
MSG: multi_interface_roam/InterfaceStatus
int8 STATE_NO_INTERFACE = -1 # The interface does not exist.
int8 STATE_PLUGGED = 0       # The interface exists.
int8 STATE_UP = 1            # The interface is up.
int8 STATE_LINK = 2          # The interface has a link.
int8 STATE_LINK_ADDR = 3     # The interface has a link, and the link has an address.
int8 STATE_ADDR = 4          # The interface has an address.
int8 STATE_PINGING = 5       # Ping packets are making it through.

string pretty_name           # The pretty name of the interface.
string interface             # The name of the interface.
int8 state                   # The state (defined above).
int32 active_interface_rank  # The rank among active interfaces (e.g. 0 for the best active interface) or -1 if inactive
float32 goodness             # How well this interface is sending packets.
float32 reliability          # How reliable this interface is expected to be.
float32 score                # The score use to rank interfaces.
float32 prescore             # The score use to rank interfaces without penalizing radios that are not active.
float32 latency              # Latency of ping packets.
float32 loss                 # Loss of ping packets.
wpa_supplicant_node/Bss bss  # Current BSS (for a wireless network)

================================================================================
MSG: wpa_supplicant_node/Bss
time stamp
string ssid
uint8[6] bssid
int32 frequency # In MHz
int16 beacon_interval
int16 capabilities
int32 quality
int32 noise
int32 level
SecurityProperties wpa
SecurityProperties rsn

#InformationElement []ies
#InformationElement []beacon_ies
# flags
# tsf
# age

================================================================================
MSG: wpa_supplicant_node/SecurityProperties
string[] key_mgmt
string[] group
string[] pairwise

"""
  __slots__ = ['interfaces']
  _slot_types = ['multi_interface_roam/InterfaceStatus[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       interfaces
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(MultiInterfaceStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.interfaces is None:
        self.interfaces = []
    else:
      self.interfaces = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      length = len(self.interfaces)
      buff.write(_struct_I.pack(length))
      for val1 in self.interfaces:
        _x = val1.pretty_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.interface
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_bi6f.pack(_x.state, _x.active_interface_rank, _x.goodness, _x.reliability, _x.score, _x.prescore, _x.latency, _x.loss))
        _v1 = val1.bss
        _v2 = _v1.stamp
        _x = _v2
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v1.ssid
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v1.bssid
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(_struct_6B.pack(*_x))
        else:
          buff.write(_struct_6s.pack(_x))
        _x = _v1
        buff.write(_struct_i2h3i.pack(_x.frequency, _x.beacon_interval, _x.capabilities, _x.quality, _x.noise, _x.level))
        _v3 = _v1.wpa
        length = len(_v3.key_mgmt)
        buff.write(_struct_I.pack(length))
        for val4 in _v3.key_mgmt:
          length = len(val4)
          buff.write(struct.pack('<I%ss'%length, length, val4))
        length = len(_v3.group)
        buff.write(_struct_I.pack(length))
        for val4 in _v3.group:
          length = len(val4)
          buff.write(struct.pack('<I%ss'%length, length, val4))
        length = len(_v3.pairwise)
        buff.write(_struct_I.pack(length))
        for val4 in _v3.pairwise:
          length = len(val4)
          buff.write(struct.pack('<I%ss'%length, length, val4))
        _v4 = _v1.rsn
        length = len(_v4.key_mgmt)
        buff.write(_struct_I.pack(length))
        for val4 in _v4.key_mgmt:
          length = len(val4)
          buff.write(struct.pack('<I%ss'%length, length, val4))
        length = len(_v4.group)
        buff.write(_struct_I.pack(length))
        for val4 in _v4.group:
          length = len(val4)
          buff.write(struct.pack('<I%ss'%length, length, val4))
        length = len(_v4.pairwise)
        buff.write(_struct_I.pack(length))
        for val4 in _v4.pairwise:
          length = len(val4)
          buff.write(struct.pack('<I%ss'%length, length, val4))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.interfaces = []
      for i in range(0, length):
        val1 = multi_interface_roam.msg.InterfaceStatus()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.pretty_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.interface = str[start:end]
        _x = val1
        start = end
        end += 29
        (_x.state, _x.active_interface_rank, _x.goodness, _x.reliability, _x.score, _x.prescore, _x.latency, _x.loss,) = _struct_bi6f.unpack(str[start:end])
        _v5 = val1.bss
        _v6 = _v5.stamp
        _x = _v6
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v5.ssid = str[start:end]
        start = end
        end += 6
        _v5.bssid = str[start:end]
        _x = _v5
        start = end
        end += 20
        (_x.frequency, _x.beacon_interval, _x.capabilities, _x.quality, _x.noise, _x.level,) = _struct_i2h3i.unpack(str[start:end])
        _v7 = _v5.wpa
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v7.key_mgmt = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val4 = str[start:end]
          _v7.key_mgmt.append(val4)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v7.group = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val4 = str[start:end]
          _v7.group.append(val4)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v7.pairwise = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val4 = str[start:end]
          _v7.pairwise.append(val4)
        _v8 = _v5.rsn
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v8.key_mgmt = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val4 = str[start:end]
          _v8.key_mgmt.append(val4)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v8.group = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val4 = str[start:end]
          _v8.group.append(val4)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v8.pairwise = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val4 = str[start:end]
          _v8.pairwise.append(val4)
        self.interfaces.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      length = len(self.interfaces)
      buff.write(_struct_I.pack(length))
      for val1 in self.interfaces:
        _x = val1.pretty_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.interface
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_bi6f.pack(_x.state, _x.active_interface_rank, _x.goodness, _x.reliability, _x.score, _x.prescore, _x.latency, _x.loss))
        _v9 = val1.bss
        _v10 = _v9.stamp
        _x = _v10
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v9.ssid
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v9.bssid
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(_struct_6B.pack(*_x))
        else:
          buff.write(_struct_6s.pack(_x))
        _x = _v9
        buff.write(_struct_i2h3i.pack(_x.frequency, _x.beacon_interval, _x.capabilities, _x.quality, _x.noise, _x.level))
        _v11 = _v9.wpa
        length = len(_v11.key_mgmt)
        buff.write(_struct_I.pack(length))
        for val4 in _v11.key_mgmt:
          length = len(val4)
          buff.write(struct.pack('<I%ss'%length, length, val4))
        length = len(_v11.group)
        buff.write(_struct_I.pack(length))
        for val4 in _v11.group:
          length = len(val4)
          buff.write(struct.pack('<I%ss'%length, length, val4))
        length = len(_v11.pairwise)
        buff.write(_struct_I.pack(length))
        for val4 in _v11.pairwise:
          length = len(val4)
          buff.write(struct.pack('<I%ss'%length, length, val4))
        _v12 = _v9.rsn
        length = len(_v12.key_mgmt)
        buff.write(_struct_I.pack(length))
        for val4 in _v12.key_mgmt:
          length = len(val4)
          buff.write(struct.pack('<I%ss'%length, length, val4))
        length = len(_v12.group)
        buff.write(_struct_I.pack(length))
        for val4 in _v12.group:
          length = len(val4)
          buff.write(struct.pack('<I%ss'%length, length, val4))
        length = len(_v12.pairwise)
        buff.write(_struct_I.pack(length))
        for val4 in _v12.pairwise:
          length = len(val4)
          buff.write(struct.pack('<I%ss'%length, length, val4))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.interfaces = []
      for i in range(0, length):
        val1 = multi_interface_roam.msg.InterfaceStatus()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.pretty_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.interface = str[start:end]
        _x = val1
        start = end
        end += 29
        (_x.state, _x.active_interface_rank, _x.goodness, _x.reliability, _x.score, _x.prescore, _x.latency, _x.loss,) = _struct_bi6f.unpack(str[start:end])
        _v13 = val1.bss
        _v14 = _v13.stamp
        _x = _v14
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v13.ssid = str[start:end]
        start = end
        end += 6
        _v13.bssid = str[start:end]
        _x = _v13
        start = end
        end += 20
        (_x.frequency, _x.beacon_interval, _x.capabilities, _x.quality, _x.noise, _x.level,) = _struct_i2h3i.unpack(str[start:end])
        _v15 = _v13.wpa
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v15.key_mgmt = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val4 = str[start:end]
          _v15.key_mgmt.append(val4)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v15.group = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val4 = str[start:end]
          _v15.group.append(val4)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v15.pairwise = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val4 = str[start:end]
          _v15.pairwise.append(val4)
        _v16 = _v13.rsn
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v16.key_mgmt = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val4 = str[start:end]
          _v16.key_mgmt.append(val4)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v16.group = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val4 = str[start:end]
          _v16.group.append(val4)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v16.pairwise = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val4 = str[start:end]
          _v16.pairwise.append(val4)
        self.interfaces.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_6B = struct.Struct("<6B")
_struct_bi6f = struct.Struct("<bi6f")
_struct_2I = struct.Struct("<2I")
_struct_6s = struct.Struct("<6s")
_struct_i2h3i = struct.Struct("<i2h3i")
