"""autogenerated by genmsg_py from UdpMonitor.msg. Do not edit."""
import roslib.message
import struct

import std_msgs.msg

class UdpMonitor(roslib.message.Message):
  _md5sum = "61e78eeecffb9257ae40ca291408f8cc"
  _type = "network_monitor_udp/UdpMonitor"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header

# Summary of the client settings
string server_host
uint32 server_port
string source_interface
float32 packet_rate
uint32 packet_size

# Proportion of packets that have latencies within a bin. The first bin
# starts at zero, bins end at the value in latency_bin_values. 
# len(latency_bin_values) = len(latency_bin_limits) + 1
float32[] latency_bin_limits
float32[] latency_bin_values

# Average latency in seconds and loss rate (between 0 and 1) for packets
# that fall within one of the bins.
float32 average_latency_fresh
float32 loss_fresh

# Average latency in seconds for all
# received packets, including very old ones.
float32 average_latency_all

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['header','server_host','server_port','source_interface','packet_rate','packet_size','latency_bin_limits','latency_bin_values','average_latency_fresh','loss_fresh','average_latency_all']
  _slot_types = ['Header','string','uint32','string','float32','uint32','float32[]','float32[]','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       header,server_host,server_port,source_interface,packet_rate,packet_size,latency_bin_limits,latency_bin_values,average_latency_fresh,loss_fresh,average_latency_all
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(UdpMonitor, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.server_host is None:
        self.server_host = ''
      if self.server_port is None:
        self.server_port = 0
      if self.source_interface is None:
        self.source_interface = ''
      if self.packet_rate is None:
        self.packet_rate = 0.
      if self.packet_size is None:
        self.packet_size = 0
      if self.latency_bin_limits is None:
        self.latency_bin_limits = []
      if self.latency_bin_values is None:
        self.latency_bin_values = []
      if self.average_latency_fresh is None:
        self.average_latency_fresh = 0.
      if self.loss_fresh is None:
        self.loss_fresh = 0.
      if self.average_latency_all is None:
        self.average_latency_all = 0.
    else:
      self.header = std_msgs.msg._Header.Header()
      self.server_host = ''
      self.server_port = 0
      self.source_interface = ''
      self.packet_rate = 0.
      self.packet_size = 0
      self.latency_bin_limits = []
      self.latency_bin_values = []
      self.average_latency_fresh = 0.
      self.loss_fresh = 0.
      self.average_latency_all = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.server_host
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_I.pack(self.server_port))
      _x = self.source_interface
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_fI.pack(_x.packet_rate, _x.packet_size))
      length = len(self.latency_bin_limits)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.latency_bin_limits))
      length = len(self.latency_bin_values)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.latency_bin_values))
      _x = self
      buff.write(_struct_3f.pack(_x.average_latency_fresh, _x.loss_fresh, _x.average_latency_all))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.server_host = str[start:end]
      start = end
      end += 4
      (self.server_port,) = _struct_I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.source_interface = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.packet_rate, _x.packet_size,) = _struct_fI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.latency_bin_limits = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.latency_bin_values = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 12
      (_x.average_latency_fresh, _x.loss_fresh, _x.average_latency_all,) = _struct_3f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.server_host
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_I.pack(self.server_port))
      _x = self.source_interface
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_fI.pack(_x.packet_rate, _x.packet_size))
      length = len(self.latency_bin_limits)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.latency_bin_limits.tostring())
      length = len(self.latency_bin_values)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.latency_bin_values.tostring())
      _x = self
      buff.write(_struct_3f.pack(_x.average_latency_fresh, _x.loss_fresh, _x.average_latency_all))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.server_host = str[start:end]
      start = end
      end += 4
      (self.server_port,) = _struct_I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.source_interface = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.packet_rate, _x.packet_size,) = _struct_fI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.latency_bin_limits = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.latency_bin_values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 12
      (_x.average_latency_fresh, _x.loss_fresh, _x.average_latency_all,) = _struct_3f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_fI = struct.Struct("<fI")
_struct_3I = struct.Struct("<3I")
_struct_3f = struct.Struct("<3f")
